#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>
typedef  void far  (*Func)(HDC hDC, int x, int y);

//  .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw: public TFrameWindow
{
  public:
	 TWndw (TWindow *parent, const char far *title);
	 ~TWndw ();
  protected:
	 void EvLButtonDown (UINT, TPoint &point);
	 void EvRButtonDown (UINT, TPoint &point);
	 void EvMButtonDown (UINT, TPoint &point);
  private:
	  HINSTANCE L;

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
			 EV_WM_LBUTTONDOWN,
			 EV_WM_RBUTTONDOWN,
			 EV_WM_MBUTTONDOWN,
END_RESPONSE_TABLE;

//***********************************
//   TWndw.
//***********************************
// TWndw::TWndw()
//    .
TWndw::TWndw (TWindow *parent, const char far *title) :
			TFrameWindow (parent, title)
{
  //     .
  Attr.X = 40;
  Attr.Y = 40;
  Attr.W = GetSystemMetrics (SM_CXSCREEN) / 1.5;
  Attr.H = GetSystemMetrics (SM_CYSCREEN) / 1.5;
  L = LoadLibrary ("shapelib.dll");
  if (!L) MessageBox("  DLL","", MB_OK);
}

// TWndw::~TWndw()
//    .
TWndw::~TWndw ()
{
  //  ,   .
  if (L) FreeLibrary(L);
}

// TWndw::EvLButtonDown()
//           WM_LBUTTONDOWN.
void TWndw::EvLButtonDown (UINT, TPoint &point)
{
  //       .
  TClientDC DC(HWindow);
  //    DLL.
  Func F =(Func)GetProcAddress(L,"Fred");
  if (!F) MessageBox("   Fred","", MB_OK);
  else
	 (*F)(HDC(DC), point.x, point.y);
}

// TWndw::EvMButtonDown()
//           WM_MBUTTONDOWN.
void TWndw::EvMButtonDown (UINT, TPoint &point)
{
  //       .
  TClientDC DC(HWindow);
  //    DLL.
  Func F =(Func)GetProcAddress(L,"Squiggle");
  if (!F) MessageBox("   Squiggle","", MB_OK);
  else
	 (*F)(HDC(DC), point.x, point.y);
}

// TWndw::EvRButtonDown()
//           WM_RBUTTONDOWN.
void TWndw::EvRButtonDown (UINT, TPoint &point)
{
  //       .
  TClientDC DC(HWindow);
  //    DLL.
  Func F =(Func)GetProcAddress(L,"Triangle");
  if (!F) MessageBox("   Triangle","", MB_OK);
  else
	 (*F)(HDC(DC), point.x, point.y);
}


//***********************************
//   TApp.
//***********************************
// TApp::InitMainWindow()
//      .
void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0, "  DLL");
  //   .
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
